=== Apps/ARCalibration/CMakeLists.txt ===
fwLoadProperties()

generic_install()
