=== Apps/OgreViewer/CMakeLists.txt ===
fwLoadProperties()

generic_install()
