=== Apps/VRRender/CMakeLists.txt ===
fwLoadProperties()

generic_install()
