=== Bundles/activity/2DVisualizationActivity/CMakeLists.txt ===
fwLoadProperties()
