=== debian/changelog ===
sight (19.0.0-5ubuntu4) focal; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 05 Mar 2020 08:56:28 +0100

sight (19.0.0-5ubuntu3) focal; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 03 Mar 2020 21:23:18 +0100

sight (19.0.0-5ubuntu2) focal; urgency=medium

  * No-change rebuild against libboost-regex1.71.0-icu65

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 13 Feb 2020 19:05:08 +0000

sight (19.0.0-5ubuntu1) focal; urgency=medium

  * Fix spelling of boost regex component.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 06 Feb 2020 04:26:25 +0000

sight (19.0.0-5build1) focal; urgency=medium

  * No change rebuild against new boost1.71 ABI

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Sun, 02 Feb 2020 20:28:36 +0100

sight (19.0.0-5) unstable; urgency=medium

  * Team upload.
  * Drop explicit Depends: libvtk7.1-qt
    Closes: #948741

 -- Andreas Tille <tille@debian.org>  Sun, 12 Jan 2020 20:54:58 +0100

sight (19.0.0-4) unstable; urgency=medium

  * Team upload.
  * Drop explicit Build-Depends: libvtk7.1-qt
    Closes: #948368
  * Refer to common license file for BSD.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Refer to specific version of license GPL-3+, LGPL-3+.

 -- Andreas Tille <tille@debian.org>  Wed, 08 Jan 2020 11:36:37 +0100

sight (19.0.0-3) unstable; urgency=medium

  * d/control: update to gdcm3 for -dev, remove libminc-dev

 -- Flavien Bridault <fbridault@ircad.fr>  Tue, 17 Dec 2019 08:33:30 +0000

sight (19.0.0-2) unstable; urgency=medium

  [ Flavien Bridault ]
  * cme fix dpkg
  * Standards-Version: 4.4.1
  * d/p/fix-glm-missing-cmake.patch: add patch to be compatible with glm 0.9.9.6
  * d/control: add transitive dependency for ITK, update to gdcm 3

  [ Andreas Tille ]
  * debhelper-compat 12
  * Respect DEB_BUILD_OPTIONS in override_dh_auto_test target
  * Remove trailing whitespace in debian/changelog
  * Remove trailing whitespace in debian/control
  * Remove trailing whitespace in debian/rules
  * Trim trailing whitespace.
  * Fix day-of-week for changelog entry 0.9.2-4.

 -- Flavien Bridault <fbridault@ircad.fr>  Wed, 04 Dec 2019 11:22:04 +0000

sight (19.0.0-1) unstable; urgency=medium

  * New upstream version
  * d/p/: updated patches
  * d/p/fix_version_getter.patch: add patch to not use git during configuring

 -- Flavien Bridault <fbridault@ircad.fr>  Mon, 02 Sep 2019 06:41:05 +0000

sight (18.1.0-1) unstable; urgency=medium

  [ Andreas Tille ]
  * Move package repository to sight

  [ Flavien Bridault ]
  * d/control: rename fw4spl to sight
    Depends now on vtk7
  * d/copyright: update credits, urls and licence version
  * d/rules: rename fw4spl to sight
  * d/watch: update upstream url
  * d/p/: remove patches merged upstream
  * */Courier.ttf: remove file not allowed for redistribution


 -- Flavien Bridault <fbridault@ircad.fr>  Sun, 04 Aug 2019 16:59:10 +0000

fw4spl (17.2.0-2) unstable; urgency=medium

  [ Flavien Bridault ]
  * d/p/: add patch to build with dcmtk 3.6.4. Closes: #920457

  [ Andreas Tille ]
  * Standards-Version: 4.3.0

 -- Flavien Bridault <fbridault@ircad.fr>  Sun, 03 Feb 2019 09:34:17 +0000

fw4spl (17.2.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Point Vcs fields to salsa.debian.org
  * Standards-Version: 4.2.1

 -- Andreas Tille <tille@debian.org>  Thu, 01 Nov 2018 12:42:50 +0100

fw4spl (14.0.0-1) unstable; urgency=medium

  [ Flavien Bridault ]
  * New upstream version
  * d/p/: remove obsolete patches
    Add patch to enable experimental GLM extension. Closes: #888932
  * d/rules: update build options

  [ Andreas Tille ]
  * Standards-Version: 4.1.3
  * debhelper 11

 -- Flavien Bridault <fbridault@ircad.fr>  Wed, 28 Feb 2018 13:24:10 +0000

fw4spl (11.0.4-2) unstable; urgency=medium

  * Team upload.
  * d/control: Move to standards version 4.0.1
  * d/p/: Add patch fix_functional_include, Closes: #871111

 -- Gert Wollny <gewo@debian.org>  Mon, 21 Aug 2017 12:26:44 +0000

fw4spl (11.0.4-1) unstable; urgency=medium

  [ Andreas Tille ]
  * Team upload
  * Fix Homepage
    Closes: #812904

  [ Flavien Bridault ]
  * New upstream version
    Support libpng16. Closes: #809935.
    Support vtk6. Closes: #820632.
    Support insighttoolkit4. Closes: #821957.
    Support gcc5 build. Closes: #793240.
  * Removed Corentin Desfarges as Uploader
  * Added myself as Uploader
  * d/watch: Moved to official fw4spl fork
  * debhelper 10 (which enables parallel build as default). Closes: #797475.
  * d/control: Updated dependencies
  * cme fix dpkg-control

 -- Flavien Bridault <fbridault@ircad.fr>  Wed, 23 Nov 2016 09:58:17 +0100

fw4spl (0.9.2-4) unstable; urgency=medium

  * Fix arm support.
  * Remove restriction to amd64.
  * Update dependencies in d/control.
  * Support new boost version. Closes: #797481.
  * Forbid parallel build. Closes: #797475.

 -- Corentin Desfarges <corentin.desfarges.dev@gmail.com>  Mon, 21 Dec 2015 14:11:13 +0200

fw4spl (0.9.2-3) unstable; urgency=medium

  * Restrict package to amd64. Closes: #790288.

 -- Corentin Desfarges <corentin.desfarges.dev@gmail.com>  Thu, 16 Jul 2015 11:16:32 +0200

fw4spl (0.9.2-2) unstable; urgency=medium

  * Replace files from libqt4-qt3support by symlinks. Closes: #781298.
  * Fix FindHdf5.cmake to find hdf5 on i386 arch. Closes: #781294.

 -- Corentin Desfarges <corentin.desfarges.dev@gmail.com>  Fri, 27 Mar 2015 17:03:34 +0100

fw4spl (0.9.2-1) unstable; urgency=low

  * Initial release (Closes: #779632)

 -- Corentin Desfarges <corentin.desfarges.dev@gmail.com>  Mon, 23 Mar 2015 11:19:00 +0100
