=== debian/rules ===
#!/usr/bin/make -f

#fix the lintian "hardening" message
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk

CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS)
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS) -Wl,--as-needed

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_BUILD_WITH_INSTALL_RPATH=FALSE -DUSE_SYSTEM_LIB=ON -DPROJECTS_TO_BUILD="VRRender" -DPROJECTS_TO_INSTALL="VRRender" -DCMAKE_INSTALL_RPATH="/usr/lib/$(DEB_HOST_MULTIARCH)/sight" -Wno-dev -DENABLE_PCH=OFF -DBUILD_TESTS=OFF -DBUILD_SDK=ON -DGIT_TAG=$(DEB_VERSION_UPSTREAM) -DCMAKE_BUILD_TYPE=Release

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	echo "test disabled"
endif

override_dh_shlibdeps:
	dh_shlibdeps -v -l/usr/lib/$(DEB_HOST_MULTIARCH):/usr/lib/$(DEB_HOST_MULTIARCH)/sight:/usr/lib/$(DEB_HOST_MULTIARCH)/sight/Bundles:/usr/lib/$(DEB_HOST_MULTIARCH)/sight/gui_0-1/:/usr/lib/$(DEB_HOST_MULTIARCH)/sight/io_0-1/:/usr/lib/$(DEB_HOST_MULTIARCH)/sight/ctrlSelection_0-1/:/usr/lib/$(DEB_HOST_MULTIARCH)/sight/ioITK_0-1/
