=== debian/changelog ===
sight (20.0.0-2) unstable; urgency=medium

  * d/p: add new patch to fix i386 build
    Closes: #964401

 -- Flavien Bridault <fbridault@ircad.fr>  Fri, 24 Jul 2020 13:37:53 +0000

sight (20.0.0-1) unstable; urgency=medium

  * New upstream version 
  * d/p/: remove patches merged upstream
    Add new patch to remove the shell extension from /usr/bin/vrrender
  * d/control: replace libcamp0.7-dev with libcamp

 -- Flavien Bridault <fbridault@ircad.fr>  Thu, 25 Jun 2020 20:41:52 +0000

sight (19.0.0-6.1) unstable; urgency=high

  * Non-maintainer upload.
  * Add patch from Giovanni Mascellani for FTBFS with Boost 1.71.
    (Closes: #954711)

 -- Adrian Bunk <bunk@debian.org>  Mon, 15 Jun 2020 18:20:23 +0300

sight (19.0.0-6) unstable; urgency=medium

  [ Etienne Mollier ]
  * Team upload.
  * Hardcoded $me and $rootdir into the vrrender launcher for usrmerge support
    Closes: #958089
  * Changed manpages location to follow binaries embedded in libsight
  * Updated a copyright entry from BSD to LGPL-3+ per current header
  * Removed now unneeded ld flags per lintian warning

  [ Andreas Tille ]
  * Standards-Version: 4.5.0 (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)

 -- Etienne Mollier <etienne.mollier@mailoo.org>  Sat, 25 Apr 2020 14:47:51 +0200
