=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: sight
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
+Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Flavien Bridault <fbridault@ircad.fr>
 Section: science
 Priority: optional
@@ -22,7 +21,7 @@
                libann-dev,
                libvtkgdcm-dev,
                libvtk7-qt-dev,
-               libcamp0.7-dev,
+               libcamp-dev,
                libglm-dev,
                xvfb,
                xauth,
@@ -30,10 +29,11 @@
                dbus-x11,
                rdfind,
                symlinks
-Standards-Version: 4.4.1
+Standards-Version: 4.5.0
 Vcs-Browser: https://salsa.debian.org/med-team/sight
 Vcs-Git: https://salsa.debian.org/med-team/sight.git
 Homepage: https://git.ircad.fr/Sight/sight
+Rules-Requires-Root: no
 
 Package: libsight
 Architecture: any
@@ -82,7 +82,7 @@
          libann-dev,
          libvtkgdcm-dev,
          libvtk7-qt-dev,
-         libcamp0.7-dev,
+         libcamp-dev,
          libglm-dev,
          ${shlibs:Depends},
          ${misc:Depends}
