=== debian/rules ===
--- 
+++ 
@@ -11,7 +11,7 @@
 CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
 CFLAGS:=$(shell dpkg-buildflags --get CFLAGS)
 CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS)
-LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS) -Wl,--as-needed
+LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)
 
 %:
 	dh $@
@@ -26,3 +26,9 @@
 
 override_dh_shlibdeps:
 	dh_shlibdeps -v -l/usr/lib/$(DEB_HOST_MULTIARCH):/usr/lib/$(DEB_HOST_MULTIARCH)/sight:/usr/lib/$(DEB_HOST_MULTIARCH)/sight/Bundles:/usr/lib/$(DEB_HOST_MULTIARCH)/sight/gui_0-1/:/usr/lib/$(DEB_HOST_MULTIARCH)/sight/io_0-1/:/usr/lib/$(DEB_HOST_MULTIARCH)/sight/ctrlSelection_0-1/:/usr/lib/$(DEB_HOST_MULTIARCH)/sight/ioITK_0-1/
+
+override_dh_install:
+	dh_install
+	sed -i -e 's@^me=.*$$@me=/usr/bin@' \
+		-e 's@^rootdir=.*$$@rootdir=/usr@' \
+		debian/vrrender/usr/bin/vrrender
